// Code generated by protoc-gen-go. DO NOT EDIT.
// source: agent-api.proto

package api

import (
	context "context"
	fmt "fmt"
	proto "github.com/golang/protobuf/proto"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
	math "math"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion3 // please upgrade the proto package

type RecordSearch struct {
	Zone                 string   `protobuf:"bytes,1,opt,name=zone,proto3" json:"zone,omitempty"`
	Name                 string   `protobuf:"bytes,2,opt,name=name,proto3" json:"name,omitempty"`
	Type                 string   `protobuf:"bytes,3,opt,name=type,proto3" json:"type,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *RecordSearch) Reset()         { *m = RecordSearch{} }
func (m *RecordSearch) String() string { return proto.CompactTextString(m) }
func (*RecordSearch) ProtoMessage()    {}
func (*RecordSearch) Descriptor() ([]byte, []int) {
	return fileDescriptor_90d1107f9d0a7970, []int{0}
}

func (m *RecordSearch) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_RecordSearch.Unmarshal(m, b)
}
func (m *RecordSearch) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_RecordSearch.Marshal(b, m, deterministic)
}
func (m *RecordSearch) XXX_Merge(src proto.Message) {
	xxx_messageInfo_RecordSearch.Merge(m, src)
}
func (m *RecordSearch) XXX_Size() int {
	return xxx_messageInfo_RecordSearch.Size(m)
}
func (m *RecordSearch) XXX_DiscardUnknown() {
	xxx_messageInfo_RecordSearch.DiscardUnknown(m)
}

var xxx_messageInfo_RecordSearch proto.InternalMessageInfo

func (m *RecordSearch) GetZone() string {
	if m != nil {
		return m.Zone
	}
	return ""
}

func (m *RecordSearch) GetName() string {
	if m != nil {
		return m.Name
	}
	return ""
}

func (m *RecordSearch) GetType() string {
	if m != nil {
		return m.Type
	}
	return ""
}

type RecordList struct {
	Items                []*Record `protobuf:"bytes,1,rep,name=items,proto3" json:"items,omitempty"`
	XXX_NoUnkeyedLiteral struct{}  `json:"-"`
	XXX_unrecognized     []byte    `json:"-"`
	XXX_sizecache        int32     `json:"-"`
}

func (m *RecordList) Reset()         { *m = RecordList{} }
func (m *RecordList) String() string { return proto.CompactTextString(m) }
func (*RecordList) ProtoMessage()    {}
func (*RecordList) Descriptor() ([]byte, []int) {
	return fileDescriptor_90d1107f9d0a7970, []int{1}
}

func (m *RecordList) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_RecordList.Unmarshal(m, b)
}
func (m *RecordList) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_RecordList.Marshal(b, m, deterministic)
}
func (m *RecordList) XXX_Merge(src proto.Message) {
	xxx_messageInfo_RecordList.Merge(m, src)
}
func (m *RecordList) XXX_Size() int {
	return xxx_messageInfo_RecordList.Size(m)
}
func (m *RecordList) XXX_DiscardUnknown() {
	xxx_messageInfo_RecordList.DiscardUnknown(m)
}

var xxx_messageInfo_RecordList proto.InternalMessageInfo

func (m *RecordList) GetItems() []*Record {
	if m != nil {
		return m.Items
	}
	return nil
}

type Record struct {
	Zone                 string   `protobuf:"bytes,1,opt,name=zone,proto3" json:"zone,omitempty"`
	Name                 string   `protobuf:"bytes,2,opt,name=name,proto3" json:"name,omitempty"`
	Type                 string   `protobuf:"bytes,3,opt,name=type,proto3" json:"type,omitempty"`
	Data                 string   `protobuf:"bytes,4,opt,name=data,proto3" json:"data,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *Record) Reset()         { *m = Record{} }
func (m *Record) String() string { return proto.CompactTextString(m) }
func (*Record) ProtoMessage()    {}
func (*Record) Descriptor() ([]byte, []int) {
	return fileDescriptor_90d1107f9d0a7970, []int{2}
}

func (m *Record) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_Record.Unmarshal(m, b)
}
func (m *Record) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_Record.Marshal(b, m, deterministic)
}
func (m *Record) XXX_Merge(src proto.Message) {
	xxx_messageInfo_Record.Merge(m, src)
}
func (m *Record) XXX_Size() int {
	return xxx_messageInfo_Record.Size(m)
}
func (m *Record) XXX_DiscardUnknown() {
	xxx_messageInfo_Record.DiscardUnknown(m)
}

var xxx_messageInfo_Record proto.InternalMessageInfo

func (m *Record) GetZone() string {
	if m != nil {
		return m.Zone
	}
	return ""
}

func (m *Record) GetName() string {
	if m != nil {
		return m.Name
	}
	return ""
}

func (m *Record) GetType() string {
	if m != nil {
		return m.Type
	}
	return ""
}

func (m *Record) GetData() string {
	if m != nil {
		return m.Data
	}
	return ""
}

type AddRecordResult struct {
	Success              bool     `protobuf:"varint,1,opt,name=success,proto3" json:"success,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *AddRecordResult) Reset()         { *m = AddRecordResult{} }
func (m *AddRecordResult) String() string { return proto.CompactTextString(m) }
func (*AddRecordResult) ProtoMessage()    {}
func (*AddRecordResult) Descriptor() ([]byte, []int) {
	return fileDescriptor_90d1107f9d0a7970, []int{3}
}

func (m *AddRecordResult) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_AddRecordResult.Unmarshal(m, b)
}
func (m *AddRecordResult) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_AddRecordResult.Marshal(b, m, deterministic)
}
func (m *AddRecordResult) XXX_Merge(src proto.Message) {
	xxx_messageInfo_AddRecordResult.Merge(m, src)
}
func (m *AddRecordResult) XXX_Size() int {
	return xxx_messageInfo_AddRecordResult.Size(m)
}
func (m *AddRecordResult) XXX_DiscardUnknown() {
	xxx_messageInfo_AddRecordResult.DiscardUnknown(m)
}

var xxx_messageInfo_AddRecordResult proto.InternalMessageInfo

func (m *AddRecordResult) GetSuccess() bool {
	if m != nil {
		return m.Success
	}
	return false
}

type DeleteRecordResult struct {
	Success              bool     `protobuf:"varint,1,opt,name=success,proto3" json:"success,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *DeleteRecordResult) Reset()         { *m = DeleteRecordResult{} }
func (m *DeleteRecordResult) String() string { return proto.CompactTextString(m) }
func (*DeleteRecordResult) ProtoMessage()    {}
func (*DeleteRecordResult) Descriptor() ([]byte, []int) {
	return fileDescriptor_90d1107f9d0a7970, []int{4}
}

func (m *DeleteRecordResult) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_DeleteRecordResult.Unmarshal(m, b)
}
func (m *DeleteRecordResult) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_DeleteRecordResult.Marshal(b, m, deterministic)
}
func (m *DeleteRecordResult) XXX_Merge(src proto.Message) {
	xxx_messageInfo_DeleteRecordResult.Merge(m, src)
}
func (m *DeleteRecordResult) XXX_Size() int {
	return xxx_messageInfo_DeleteRecordResult.Size(m)
}
func (m *DeleteRecordResult) XXX_DiscardUnknown() {
	xxx_messageInfo_DeleteRecordResult.DiscardUnknown(m)
}

var xxx_messageInfo_DeleteRecordResult proto.InternalMessageInfo

func (m *DeleteRecordResult) GetSuccess() bool {
	if m != nil {
		return m.Success
	}
	return false
}

func init() {
	proto.RegisterType((*RecordSearch)(nil), "api.RecordSearch")
	proto.RegisterType((*RecordList)(nil), "api.RecordList")
	proto.RegisterType((*Record)(nil), "api.Record")
	proto.RegisterType((*AddRecordResult)(nil), "api.AddRecordResult")
	proto.RegisterType((*DeleteRecordResult)(nil), "api.DeleteRecordResult")
}

func init() {
	proto.RegisterFile("agent-api.proto", fileDescriptor_90d1107f9d0a7970)
}

var fileDescriptor_90d1107f9d0a7970 = []byte{
	// 264 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xa4, 0x91, 0x41, 0x4b, 0xc3, 0x50,
	0x0c, 0xc7, 0x5b, 0xbb, 0x4d, 0x97, 0x0e, 0x8a, 0x41, 0xf0, 0xb1, 0xd3, 0x7c, 0xa7, 0x81, 0x58,
	0x65, 0x03, 0xef, 0x03, 0x4f, 0xe2, 0xa9, 0x5e, 0xbc, 0x3e, 0xdb, 0xa0, 0x85, 0xad, 0x2d, 0x7d,
	0xd9, 0x41, 0x3f, 0x90, 0x9f, 0x53, 0xf2, 0xa2, 0x52, 0xf5, 0x22, 0x78, 0xfb, 0xe7, 0x97, 0xe4,
	0xfd, 0x93, 0x3c, 0xc8, 0xdc, 0x13, 0x35, 0x7c, 0xe1, 0xba, 0x3a, 0xef, 0xfa, 0x96, 0x5b, 0x4c,
	0x5c, 0x57, 0xdb, 0x5b, 0x98, 0x15, 0x54, 0xb6, 0x7d, 0x75, 0x4f, 0xae, 0x2f, 0x9f, 0x11, 0x61,
	0xf4, 0xda, 0x36, 0x64, 0xe2, 0x45, 0xbc, 0x9c, 0x16, 0x41, 0x0b, 0x6b, 0xdc, 0x8e, 0xcc, 0x81,
	0x32, 0xd1, 0xc2, 0xf8, 0xa5, 0x23, 0x93, 0x28, 0x13, 0x6d, 0x2f, 0x01, 0xf4, 0xad, 0xbb, 0xda,
	0x33, 0x9e, 0xc1, 0xb8, 0x66, 0xda, 0x79, 0x13, 0x2f, 0x92, 0x65, 0xba, 0x4a, 0x73, 0x71, 0xd6,
	0x7c, 0xa1, 0x19, 0xfb, 0x00, 0x13, 0x05, 0xff, 0xb1, 0x15, 0x56, 0x39, 0x76, 0x66, 0xa4, 0x4c,
	0xb4, 0x3d, 0x87, 0x6c, 0x53, 0x55, 0x1f, 0x6e, 0xe4, 0xf7, 0x5b, 0x46, 0x03, 0x87, 0x7e, 0x5f,
	0x96, 0xe4, 0x7d, 0x70, 0x39, 0x2a, 0x3e, 0x43, 0x9b, 0x03, 0xde, 0xd0, 0x96, 0x98, 0xfe, 0x56,
	0xbf, 0x7a, 0x8b, 0x61, 0xbc, 0x91, 0x63, 0xe2, 0x1a, 0x52, 0xd9, 0x55, 0xfb, 0x3c, 0x1e, 0x0f,
	0x76, 0xd4, 0x7b, 0xce, 0xb3, 0x01, 0x92, 0x52, 0x1b, 0xe1, 0x15, 0x4c, 0xbf, 0x66, 0xc3, 0xe1,
	0x59, 0xe6, 0x27, 0x21, 0xf8, 0x31, 0xb8, 0x8d, 0xf0, 0x1a, 0x66, 0xc3, 0x01, 0xbf, 0x37, 0x9d,
	0x86, 0xe0, 0xf7, 0x02, 0x36, 0x7a, 0x9c, 0x84, 0x8f, 0x5e, 0xbf, 0x07, 0x00, 0x00, 0xff, 0xff,
	0xb5, 0x41, 0x5e, 0xb1, 0xfb, 0x01, 0x00, 0x00,
}

// Reference imports to suppress errors if they are not otherwise used.
var _ context.Context
var _ grpc.ClientConnInterface

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
const _ = grpc.SupportPackageIsVersion6

// AgentClient is the client API for Agent service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://godoc.org/google.golang.org/grpc#ClientConn.NewStream.
type AgentClient interface {
	// ListRecords - show all List of type
	ListRecords(ctx context.Context, in *RecordSearch, opts ...grpc.CallOption) (*RecordList, error)
	// AddRecord a new record to dns
	AddRecord(ctx context.Context, in *Record, opts ...grpc.CallOption) (*AddRecordResult, error)
	// Delete an existing record from dns
	DeleteRecord(ctx context.Context, in *Record, opts ...grpc.CallOption) (*DeleteRecordResult, error)
}

type agentClient struct {
	cc grpc.ClientConnInterface
}

func NewAgentClient(cc grpc.ClientConnInterface) AgentClient {
	return &agentClient{cc}
}

func (c *agentClient) ListRecords(ctx context.Context, in *RecordSearch, opts ...grpc.CallOption) (*RecordList, error) {
	out := new(RecordList)
	err := c.cc.Invoke(ctx, "/api.Agent/ListRecords", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *agentClient) AddRecord(ctx context.Context, in *Record, opts ...grpc.CallOption) (*AddRecordResult, error) {
	out := new(AddRecordResult)
	err := c.cc.Invoke(ctx, "/api.Agent/AddRecord", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *agentClient) DeleteRecord(ctx context.Context, in *Record, opts ...grpc.CallOption) (*DeleteRecordResult, error) {
	out := new(DeleteRecordResult)
	err := c.cc.Invoke(ctx, "/api.Agent/DeleteRecord", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// AgentServer is the server API for Agent service.
type AgentServer interface {
	// ListRecords - show all List of type
	ListRecords(context.Context, *RecordSearch) (*RecordList, error)
	// AddRecord a new record to dns
	AddRecord(context.Context, *Record) (*AddRecordResult, error)
	// Delete an existing record from dns
	DeleteRecord(context.Context, *Record) (*DeleteRecordResult, error)
}

// UnimplementedAgentServer can be embedded to have forward compatible implementations.
type UnimplementedAgentServer struct {
}

func (*UnimplementedAgentServer) ListRecords(ctx context.Context, req *RecordSearch) (*RecordList, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ListRecords not implemented")
}
func (*UnimplementedAgentServer) AddRecord(ctx context.Context, req *Record) (*AddRecordResult, error) {
	return nil, status.Errorf(codes.Unimplemented, "method AddRecord not implemented")
}
func (*UnimplementedAgentServer) DeleteRecord(ctx context.Context, req *Record) (*DeleteRecordResult, error) {
	return nil, status.Errorf(codes.Unimplemented, "method DeleteRecord not implemented")
}

func RegisterAgentServer(s *grpc.Server, srv AgentServer) {
	s.RegisterService(&_Agent_serviceDesc, srv)
}

func _Agent_ListRecords_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(RecordSearch)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(AgentServer).ListRecords(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/api.Agent/ListRecords",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(AgentServer).ListRecords(ctx, req.(*RecordSearch))
	}
	return interceptor(ctx, in, info, handler)
}

func _Agent_AddRecord_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Record)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(AgentServer).AddRecord(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/api.Agent/AddRecord",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(AgentServer).AddRecord(ctx, req.(*Record))
	}
	return interceptor(ctx, in, info, handler)
}

func _Agent_DeleteRecord_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Record)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(AgentServer).DeleteRecord(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/api.Agent/DeleteRecord",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(AgentServer).DeleteRecord(ctx, req.(*Record))
	}
	return interceptor(ctx, in, info, handler)
}

var _Agent_serviceDesc = grpc.ServiceDesc{
	ServiceName: "api.Agent",
	HandlerType: (*AgentServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "ListRecords",
			Handler:    _Agent_ListRecords_Handler,
		},
		{
			MethodName: "AddRecord",
			Handler:    _Agent_AddRecord_Handler,
		},
		{
			MethodName: "DeleteRecord",
			Handler:    _Agent_DeleteRecord_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "agent-api.proto",
}
